#include <Pilot.h>

/* test to see if it is possible to read 8 bits from the given address (i.e.
 * that what's pointed to by <from> is existing memory.
 */
static int is_address_readable8(void *from);

/* test to see if it is possible to read 16 bits from the given address (i.e.
 * that what's pointed to by <from> is existing memory. Will care about
 * alignment (i.e. it's not possible to read 16 bits from an odd address).
 */
static int is_address_readable16(void *from);

/* initialize disassembler internal structures. <startaddress> is the  address
 * from which to start disassembling from; <length> is the expected number of
 * bytes there is to disassemble. */
int
initialize_disassembler(void);

/* destroy and free all disassemble internal structures and whatnot. */
void
terminate_disassembler(void);

/* Set the line-counter of the output function. */
void
disassemble_set_line(int line);

/* Decode input data at address <addr> into a single instruction. No more. No
 * less.  Returns the address of the next instruction, or NULL on failure.
 */
void *
disassemble_single_line(void *addr);
